diff options
author | Benjamin Qi | 2020-07-20 18:22:10 -0400 |
---|---|---|
committer | Benjamin Qi | 2020-07-20 18:22:10 -0400 |
commit | 210cb1ae75a3485cf2ad14468be37a269835c425 (patch) | |
tree | 6f1e092c6cae835844cd398984f4902acb8fe2d4 | |
parent | fc318b35436d1b6a3fccb12bcde8f3e438c33925 (diff) |
split complete search
-rw-r--r-- | content/2_Bronze/Complete_Search.mdx | 123 | ||||
-rw-r--r-- | content/2_Bronze/Gen_Perm.mdx | 126 | ||||
-rw-r--r-- | content/ordering.ts | 4 |
3 files changed, 135 insertions, 118 deletions
diff --git a/content/2_Bronze/Complete_Search.mdx b/content/2_Bronze/Complete_Search.mdx index 57c9e4e..0fc3dee 100644 --- a/content/2_Bronze/Complete_Search.mdx +++ b/content/2_Bronze/Complete_Search.mdx @@ -1,8 +1,8 @@ --- -id: complete-search -title: "Complete Search" -author: Darren Yao, Sam Zhang -description: "Solving bronze problems by checking all possible cases in the solution space." +id: intro-complete +title: "Introduction to Complete Search" +author: Darren Yao +description: "A basic example: iterating through all pairs." frequency: 4 --- @@ -29,20 +29,10 @@ export const problems = { new Problem("Bronze", "Bull in a China Shop", "640", "Very Hard", false, [], "lots of WA on this one"), // 47.38 new Problem("Silver", "Field Reduction", "642", "Very Hard", false, [], ""), ], - permSam: [ - new Problem("CSES", "Creating Strings I", "1622", "Intro|Easy", false, [], "all perms of string"), - ], - ex: [ - new Problem("Bronze", "Photoshoot", "988", "Normal", false, [], ""), - ], - perm: [ - new Problem("CSES", "Chessboard and Queens", "1624", "Normal", false, [], "Recursively backtrack. See CSES book for more details."), - new Problem("Bronze", "Livestock Lineup", "965", "Hard", false, ["permutations"], ""), // 91.95 - ] }; <Resources> - <Resource source="IUSACO" title="6 - Complete Search">module is based off this</Resource> + <Resource source="IUSACO" title="6 - Simulation">module is based off this</Resource> <Resource source="CPH" title="5.1 to 5.3 - Complete Search"> </Resource> </Resources> @@ -119,107 +109,6 @@ A couple notes: </Spoiler> -## Generating Permutations - -<Problems problems={problems.permSam} /> - -<br /> - -A **permutation** is a reordering of a list of elements. Some problems will ask for an ordering of elements that satisfies certain conditions. In these problems, if $N \leq 10$, we can complete search through all permutations and check each permutation for validity. For a list of $N$ elements, there are $N!$ ways to permute them, and generally we'll need to read through each permutation once to check its validity, for a time complexity of $O(N \cdot N!)$. - -<Resources> - <Resource source="GFG" url="write-a-c-program-to-print-all-permutations-of-a-given-string" title="Printing all Permutations of Given String"> </Resource> -</Resources> - -### Lexicographical Order - -This term is mentioned quite frequently: - -<Problems problems={problems.ex} /> - -Think about how are words ordered in a dictionary. (In fact, this is where the term "lexicographical" comes from.) - -In dictionaries, you will see that words beginning with the letter 'a' appears at the very beginning, followed by words beginning with 'b', and so on. If two words have the same starting letter, the second letter is used to compare them; if both the first and second letters are the same, then use the third letter to compare them, and so on until we either reach a letter that is different, or we reach the end of some word (in this case, the shorter word goes first). - -Permutations can be placed into lexicographical order in almost the same way. We first group permutations by their first element; if the first element of two permutations are equal, then we compare them by the second element; if the second element is also equal, then we compare by the third element, and so on. - -For example, the permutations of 3 elements, in lexicographical order, are - -$$ -[1, 2, 3], [1, 3, 2], [2, 1, 3], [2, 3, 1], [3, 1, 2], [3, 2, 1]. -$$ - -Notice that the list starts with permutations beginning with 1 (just like a dictionary that starts with words beginning with 'a'), followed by those beginning with 2 and those beginning with 3. Within the same starting element, the second element is used to make comparisions. - -Generally, unless you are specifically asked to find the lexicographically smallest/largest solution, you do not need to worry about whether permutations are being generated in lexicographical order. However, the idea of lexicographical order does appear quite often in programming contest problems, and in a variety of contexts, so it is strongly recommended that you familiarize yourself with its definition. - -### Checking Permutations in Lexicographical Order - -What's going to be in the `check` function depends on the problem, but it should verify whether the current permutation satisfies the constraints given in the problem. - -<LanguageSection> - -<CPPSection> - -#### Method 1 - -($O(N\cdot N!)$ code) - -<IncompleteSection /> - -#### Method 2 - -<Resources> - <Resource source="Mark Nelson" title="Next Permutation" url="https://marknelson.us/posts/2002/03/01/next-permutation.html"> </Resource> -</Resources> - -Alternatively, we can just use the [`next_permutation()`](https://en.cppreference.com/w/cpp/algorithm/next_permutation) function. This function takes in a range and modifies it to the next greater permutation. If there is no greater permutation, it returns false. To iterate through all permutations, place it inside a `do-while` loop. We are using a `do-while` loop here instead of a typical `while` loop because a `while` loop would modify the smallest permutation before we got a chance to process it. - -```cpp -do { - check(v); // process or check the current permutation for validity -} while(next_permutation(v.begin(), v.end())); -``` - -Each call to `next_permutation` makes a constant number of swaps on average if we go through all $N!$ permutations of size $N$. - -</CPPSection> - -<JavaSection> - -```java -import java.util.*; - -public class Test { - static boolean[] used; - static ArrayList<Integer> cur = new ArrayList<Integer>(); - static int n; - static void gen() { - if (cur.size() == n) { - check(cur); // check current permutation for validity, or print it, etc. - return; - } - for (int i = 0; i < n; ++i) if (!used[i]) { - used[i] = true; cur.add(i+1); - gen(); - used[i] = false; cur.remove(cur.size()-1); - } - } - static void genPerm(int _n) { - n = _n; used = new boolean[n]; - gen(); - } - public static void main(String[] Args) { - genPerm(5); - } -} -``` - -</JavaSection> - -</LanguageSection> - - ## Problems ### Easier @@ -228,4 +117,4 @@ public class Test { ### Harder -<Problems problems={problems.harder} /> +<Problems problems={problems.harder} />
\ No newline at end of file diff --git a/content/2_Bronze/Gen_Perm.mdx b/content/2_Bronze/Gen_Perm.mdx new file mode 100644 index 0000000..5535acf --- /dev/null +++ b/content/2_Bronze/Gen_Perm.mdx @@ -0,0 +1,126 @@ +--- +id: gen-perm +title: "Generating Permutations" +author: Darren Yao, Sam Zhang +description: "Methods to generate all permutations of an array, a common technique associated with complete search." +frequency: 4 +prerequisites: + - intro-complete +--- + +import { Problem } from "../models"; + +export const problems = { + permSam: [ + new Problem("CSES", "Creating Strings I", "1622", "Intro|Easy", false, [], "all perms of string"), + ], + ex: [ + new Problem("Bronze", "Photoshoot", "988", "Normal", false, [], ""), + ], + perm: [ + new Problem("CSES", "Chessboard and Queens", "1624", "Normal", false, [], "Recursively backtrack. See CSES book for more details."), + new Problem("Bronze", "Livestock Lineup", "965", "Hard", false, ["permutations"], ""), // 91.95 + ] +}; + +<Problems problems={problems.permSam} /> + +<br /> + +A **permutation** is a reordering of a list of elements. Some problems will ask for an ordering of elements that satisfies certain conditions. In these problems, if $N \leq 10$, we can probably iterate through all permutations and check each permutation for validity. For a list of $N$ elements, there are $N!$ ways to permute them, and generally we'll need to read through each permutation once to check its validity, for a time complexity of $O(N \cdot N!)$. + +<Resources> + <Resource source="GFG" url="write-a-c-program-to-print-all-permutations-of-a-given-string" title="Printing all Permutations of Given String"> </Resource> +</Resources> + +## Lexicographical Order + +This term is mentioned quite frequently: + +<Problems problems={problems.ex} /> + +Think about how are words ordered in a dictionary. (In fact, this is where the term "lexicographical" comes from.) + +In dictionaries, you will see that words beginning with the letter 'a' appears at the very beginning, followed by words beginning with 'b', and so on. If two words have the same starting letter, the second letter is used to compare them; if both the first and second letters are the same, then use the third letter to compare them, and so on until we either reach a letter that is different, or we reach the end of some word (in this case, the shorter word goes first). + +Permutations can be placed into lexicographical order in almost the same way. We first group permutations by their first element; if the first element of two permutations are equal, then we compare them by the second element; if the second element is also equal, then we compare by the third element, and so on. + +For example, the permutations of 3 elements, in lexicographical order, are + +$$ +[1, 2, 3], [1, 3, 2], [2, 1, 3], [2, 3, 1], [3, 1, 2], [3, 2, 1]. +$$ + +Notice that the list starts with permutations beginning with 1 (just like a dictionary that starts with words beginning with 'a'), followed by those beginning with 2 and those beginning with 3. Within the same starting element, the second element is used to make comparisions. + +Generally, unless you are specifically asked to find the lexicographically smallest/largest solution, you do not need to worry about whether permutations are being generated in lexicographical order. However, the idea of lexicographical order does appear quite often in programming contest problems, and in a variety of contexts, so it is strongly recommended that you familiarize yourself with its definition. + +## Checking Permutations in Lexicographical Order + +What's going to be in the `check` function depends on the problem, but it should verify whether the current permutation satisfies the constraints given in the problem. + +<LanguageSection> + +<CPPSection> + +### Method 1 + +($O(N\cdot N!)$ code) + +<IncompleteSection /> + +### Method 2 + +<Resources> + <Resource source="Mark Nelson" title="Next Permutation" url="https://marknelson.us/posts/2002/03/01/next-permutation.html"> </Resource> +</Resources> + +Alternatively, we can just use the [`next_permutation()`](https://en.cppreference.com/w/cpp/algorithm/next_permutation) function. This function takes in a range and modifies it to the next greater permutation. If there is no greater permutation, it returns false. To iterate through all permutations, place it inside a `do-while` loop. We are using a `do-while` loop here instead of a typical `while` loop because a `while` loop would modify the smallest permutation before we got a chance to process it. + +```cpp +do { + check(v); // process or check the current permutation for validity +} while(next_permutation(v.begin(), v.end())); +``` + +Each call to `next_permutation` makes a constant number of swaps on average if we go through all $N!$ permutations of size $N$. + +</CPPSection> + +<JavaSection> + +```java +import java.util.*; + +public class Test { + static boolean[] used; + static ArrayList<Integer> cur = new ArrayList<Integer>(); + static int n; + static void gen() { + if (cur.size() == n) { + check(cur); // check current permutation for validity, or print it, etc. + return; + } + for (int i = 0; i < n; ++i) if (!used[i]) { + used[i] = true; cur.add(i+1); + gen(); + used[i] = false; cur.remove(cur.size()-1); + } + } + static void genPerm(int _n) { + n = _n; used = new boolean[n]; + gen(); + } + public static void main(String[] Args) { + genPerm(5); + } +} +``` + +</JavaSection> + +</LanguageSection> + +### Problems + +<Problems problems={problems.perm} />
\ No newline at end of file diff --git a/content/ordering.ts b/content/ordering.ts index 4a4732b..625eb67 100644 --- a/content/ordering.ts +++ b/content/ordering.ts @@ -76,8 +76,10 @@ const MODULE_ORDERING: {[key in SectionID]: Chapter[]} = { }, { name: "Complete Search", + description: "Solving bronze problems by checking all possible cases in the solution space.", items: [ - "complete-search", + "intro-complete", + "gen-perm" ] }, { |